rust_is_available.sh 9.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262
  1. #!/bin/sh
  2. # SPDX-License-Identifier: GPL-2.0
  3. #
  4. # Tests whether a suitable Rust toolchain is available.
  5. set -e
  6. min_tool_version=$(dirname $0)/min-tool-version.sh
  7. # Convert the version string x.y.z to a canonical up-to-7-digits form.
  8. #
  9. # Note that this function uses one more digit (compared to other
  10. # instances in other version scripts) to give a bit more space to
  11. # `rustc` since it will reach 1.100.0 in late 2026.
  12. get_canonical_version()
  13. {
  14. IFS=.
  15. set -- $1
  16. echo $((100000 * $1 + 100 * $2 + $3))
  17. }
  18. # Print a reference to the Quick Start guide in the documentation.
  19. print_docs_reference()
  20. {
  21. echo >&2 "***"
  22. echo >&2 "*** Please see Documentation/rust/quick-start.rst for details"
  23. echo >&2 "*** on how to set up the Rust support."
  24. echo >&2 "***"
  25. }
  26. # Print an explanation about the fact that the script is meant to be called from Kbuild.
  27. print_kbuild_explanation()
  28. {
  29. echo >&2 "***"
  30. echo >&2 "*** This script is intended to be called from Kbuild."
  31. echo >&2 "*** Please use the 'rustavailable' target to call it instead."
  32. echo >&2 "*** Otherwise, the results may not be meaningful."
  33. exit 1
  34. }
  35. # If the script fails for any reason, or if there was any warning, then
  36. # print a reference to the documentation on exit.
  37. warning=0
  38. trap 'if [ $? -ne 0 ] || [ $warning -ne 0 ]; then print_docs_reference; fi' EXIT
  39. # Check that the expected environment variables are set.
  40. if [ -z "${RUSTC+x}" ]; then
  41. echo >&2 "***"
  42. echo >&2 "*** Environment variable 'RUSTC' is not set."
  43. print_kbuild_explanation
  44. fi
  45. if [ -z "${BINDGEN+x}" ]; then
  46. echo >&2 "***"
  47. echo >&2 "*** Environment variable 'BINDGEN' is not set."
  48. print_kbuild_explanation
  49. fi
  50. if [ -z "${CC+x}" ]; then
  51. echo >&2 "***"
  52. echo >&2 "*** Environment variable 'CC' is not set."
  53. print_kbuild_explanation
  54. fi
  55. # Check that the Rust compiler exists.
  56. if ! command -v "$RUSTC" >/dev/null; then
  57. echo >&2 "***"
  58. echo >&2 "*** Rust compiler '$RUSTC' could not be found."
  59. echo >&2 "***"
  60. exit 1
  61. fi
  62. # Check that the Rust bindings generator exists.
  63. if ! command -v "$BINDGEN" >/dev/null; then
  64. echo >&2 "***"
  65. echo >&2 "*** Rust bindings generator '$BINDGEN' could not be found."
  66. echo >&2 "***"
  67. exit 1
  68. fi
  69. # Check that the Rust compiler version is suitable.
  70. #
  71. # Non-stable and distributions' versions may have a version suffix, e.g. `-dev`.
  72. rust_compiler_output=$( \
  73. LC_ALL=C "$RUSTC" --version 2>/dev/null
  74. ) || rust_compiler_code=$?
  75. if [ -n "$rust_compiler_code" ]; then
  76. echo >&2 "***"
  77. echo >&2 "*** Running '$RUSTC' to check the Rust compiler version failed with"
  78. echo >&2 "*** code $rust_compiler_code. See output and docs below for details:"
  79. echo >&2 "***"
  80. echo >&2 "$rust_compiler_output"
  81. echo >&2 "***"
  82. exit 1
  83. fi
  84. rust_compiler_version=$( \
  85. echo "$rust_compiler_output" \
  86. | sed -nE '1s:.*rustc ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
  87. )
  88. if [ -z "$rust_compiler_version" ]; then
  89. echo >&2 "***"
  90. echo >&2 "*** Running '$RUSTC' to check the Rust compiler version did not return"
  91. echo >&2 "*** an expected output. See output and docs below for details:"
  92. echo >&2 "***"
  93. echo >&2 "$rust_compiler_output"
  94. echo >&2 "***"
  95. exit 1
  96. fi
  97. rust_compiler_min_version=$($min_tool_version rustc)
  98. rust_compiler_cversion=$(get_canonical_version $rust_compiler_version)
  99. rust_compiler_min_cversion=$(get_canonical_version $rust_compiler_min_version)
  100. if [ "$rust_compiler_cversion" -lt "$rust_compiler_min_cversion" ]; then
  101. echo >&2 "***"
  102. echo >&2 "*** Rust compiler '$RUSTC' is too old."
  103. echo >&2 "*** Your version: $rust_compiler_version"
  104. echo >&2 "*** Minimum version: $rust_compiler_min_version"
  105. echo >&2 "***"
  106. exit 1
  107. fi
  108. # Check that the Rust bindings generator is suitable.
  109. #
  110. # Non-stable and distributions' versions may have a version suffix, e.g. `-dev`.
  111. #
  112. # The dummy parameter `workaround-for-0.69.0` is required to support 0.69.0
  113. # (https://github.com/rust-lang/rust-bindgen/pull/2678). It can be removed when
  114. # the minimum version is upgraded past that (0.69.1 already fixed the issue).
  115. rust_bindings_generator_output=$( \
  116. LC_ALL=C "$BINDGEN" --version workaround-for-0.69.0 2>/dev/null
  117. ) || rust_bindings_generator_code=$?
  118. if [ -n "$rust_bindings_generator_code" ]; then
  119. echo >&2 "***"
  120. echo >&2 "*** Running '$BINDGEN' to check the Rust bindings generator version failed with"
  121. echo >&2 "*** code $rust_bindings_generator_code. See output and docs below for details:"
  122. echo >&2 "***"
  123. echo >&2 "$rust_bindings_generator_output"
  124. echo >&2 "***"
  125. exit 1
  126. fi
  127. rust_bindings_generator_version=$( \
  128. echo "$rust_bindings_generator_output" \
  129. | sed -nE '1s:.*bindgen ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
  130. )
  131. if [ -z "$rust_bindings_generator_version" ]; then
  132. echo >&2 "***"
  133. echo >&2 "*** Running '$BINDGEN' to check the bindings generator version did not return"
  134. echo >&2 "*** an expected output. See output and docs below for details:"
  135. echo >&2 "***"
  136. echo >&2 "$rust_bindings_generator_output"
  137. echo >&2 "***"
  138. exit 1
  139. fi
  140. rust_bindings_generator_min_version=$($min_tool_version bindgen)
  141. rust_bindings_generator_cversion=$(get_canonical_version $rust_bindings_generator_version)
  142. rust_bindings_generator_min_cversion=$(get_canonical_version $rust_bindings_generator_min_version)
  143. if [ "$rust_bindings_generator_cversion" -lt "$rust_bindings_generator_min_cversion" ]; then
  144. echo >&2 "***"
  145. echo >&2 "*** Rust bindings generator '$BINDGEN' is too old."
  146. echo >&2 "*** Your version: $rust_bindings_generator_version"
  147. echo >&2 "*** Minimum version: $rust_bindings_generator_min_version"
  148. echo >&2 "***"
  149. exit 1
  150. fi
  151. if [ "$rust_bindings_generator_cversion" -eq 6600 ] ||
  152. [ "$rust_bindings_generator_cversion" -eq 6601 ]; then
  153. # Distributions may have patched the issue (e.g. Debian did).
  154. if ! "$BINDGEN" $(dirname $0)/rust_is_available_bindgen_0_66.h >/dev/null; then
  155. echo >&2 "***"
  156. echo >&2 "*** Rust bindings generator '$BINDGEN' versions 0.66.0 and 0.66.1 may not"
  157. echo >&2 "*** work due to a bug (https://github.com/rust-lang/rust-bindgen/pull/2567),"
  158. echo >&2 "*** unless patched (like Debian's)."
  159. echo >&2 "*** Your version: $rust_bindings_generator_version"
  160. echo >&2 "***"
  161. warning=1
  162. fi
  163. fi
  164. # Check that the `libclang` used by the Rust bindings generator is suitable.
  165. #
  166. # In order to do that, first invoke `bindgen` to get the `libclang` version
  167. # found by `bindgen`. This step may already fail if, for instance, `libclang`
  168. # is not found, thus inform the user in such a case.
  169. bindgen_libclang_output=$( \
  170. LC_ALL=C "$BINDGEN" $(dirname $0)/rust_is_available_bindgen_libclang.h 2>&1 >/dev/null
  171. ) || bindgen_libclang_code=$?
  172. if [ -n "$bindgen_libclang_code" ]; then
  173. echo >&2 "***"
  174. echo >&2 "*** Running '$BINDGEN' to check the libclang version (used by the Rust"
  175. echo >&2 "*** bindings generator) failed with code $bindgen_libclang_code. This may be caused by"
  176. echo >&2 "*** a failure to locate libclang. See output and docs below for details:"
  177. echo >&2 "***"
  178. echo >&2 "$bindgen_libclang_output"
  179. echo >&2 "***"
  180. exit 1
  181. fi
  182. # `bindgen` returned successfully, thus use the output to check that the version
  183. # of the `libclang` found by the Rust bindings generator is suitable.
  184. #
  185. # Unlike other version checks, note that this one does not necessarily appear
  186. # in the first line of the output, thus no `sed` address is provided.
  187. bindgen_libclang_version=$( \
  188. echo "$bindgen_libclang_output" \
  189. | sed -nE 's:.*clang version ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
  190. )
  191. if [ -z "$bindgen_libclang_version" ]; then
  192. echo >&2 "***"
  193. echo >&2 "*** Running '$BINDGEN' to check the libclang version (used by the Rust"
  194. echo >&2 "*** bindings generator) did not return an expected output. See output"
  195. echo >&2 "*** and docs below for details:"
  196. echo >&2 "***"
  197. echo >&2 "$bindgen_libclang_output"
  198. echo >&2 "***"
  199. exit 1
  200. fi
  201. bindgen_libclang_min_version=$($min_tool_version llvm)
  202. bindgen_libclang_cversion=$(get_canonical_version $bindgen_libclang_version)
  203. bindgen_libclang_min_cversion=$(get_canonical_version $bindgen_libclang_min_version)
  204. if [ "$bindgen_libclang_cversion" -lt "$bindgen_libclang_min_cversion" ]; then
  205. echo >&2 "***"
  206. echo >&2 "*** libclang (used by the Rust bindings generator '$BINDGEN') is too old."
  207. echo >&2 "*** Your version: $bindgen_libclang_version"
  208. echo >&2 "*** Minimum version: $bindgen_libclang_min_version"
  209. echo >&2 "***"
  210. exit 1
  211. fi
  212. # If the C compiler is Clang, then we can also check whether its version
  213. # matches the `libclang` version used by the Rust bindings generator.
  214. #
  215. # In the future, we might be able to perform a full version check, see
  216. # https://github.com/rust-lang/rust-bindgen/issues/2138.
  217. cc_name=$($(dirname $0)/cc-version.sh $CC | cut -f1 -d' ')
  218. if [ "$cc_name" = Clang ]; then
  219. clang_version=$( \
  220. LC_ALL=C $CC --version 2>/dev/null \
  221. | sed -nE '1s:.*version ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
  222. )
  223. if [ "$clang_version" != "$bindgen_libclang_version" ]; then
  224. echo >&2 "***"
  225. echo >&2 "*** libclang (used by the Rust bindings generator '$BINDGEN')"
  226. echo >&2 "*** version does not match Clang's. This may be a problem."
  227. echo >&2 "*** libclang version: $bindgen_libclang_version"
  228. echo >&2 "*** Clang version: $clang_version"
  229. echo >&2 "***"
  230. warning=1
  231. fi
  232. fi
  233. # Check that the source code for the `core` standard library exists.
  234. #
  235. # `$KRUSTFLAGS` is passed in case the user added `--sysroot`.
  236. rustc_sysroot=$("$RUSTC" $KRUSTFLAGS --print sysroot)
  237. rustc_src=${RUST_LIB_SRC:-"$rustc_sysroot/lib/rustlib/src/rust/library"}
  238. rustc_src_core="$rustc_src/core/src/lib.rs"
  239. if [ ! -e "$rustc_src_core" ]; then
  240. echo >&2 "***"
  241. echo >&2 "*** Source code for the 'core' standard library could not be found"
  242. echo >&2 "*** at '$rustc_src_core'."
  243. echo >&2 "***"
  244. exit 1
  245. fi